<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKeyValueOfstringboolean ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfKeyValueOfstringboolean
 * @subpackage Arrays
 */
class ArrayOfKeyValueOfstringboolean extends AbstractStructArrayBase
{
    /**
     * The KeyValueOfstringboolean
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \patest\StructType\KeyValueOfstringboolean[]
     */
    public $KeyValueOfstringboolean;
    /**
     * Constructor method for ArrayOfKeyValueOfstringboolean
     * @uses ArrayOfKeyValueOfstringboolean::setKeyValueOfstringboolean()
     * @param \patest\StructType\KeyValueOfstringboolean[] $keyValueOfstringboolean
     */
    public function __construct(array $keyValueOfstringboolean = array())
    {
        $this
            ->setKeyValueOfstringboolean($keyValueOfstringboolean);
    }
    /**
     * Get KeyValueOfstringboolean value
     * @return \patest\StructType\KeyValueOfstringboolean[]|null
     */
    public function getKeyValueOfstringboolean()
    {
        return $this->KeyValueOfstringboolean;
    }
    /**
     * This method is responsible for validating the values passed to the setKeyValueOfstringboolean method
     * This method is willingly generated in order to preserve the one-line inline validation within the setKeyValueOfstringboolean method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateKeyValueOfstringbooleanForArrayConstraintsFromSetKeyValueOfstringboolean(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfKeyValueOfstringbooleanKeyValueOfstringbooleanItem) {
            // validation for constraint: itemType
            if (!$arrayOfKeyValueOfstringbooleanKeyValueOfstringbooleanItem instanceof \patest\StructType\KeyValueOfstringboolean) {
                $invalidValues[] = is_object($arrayOfKeyValueOfstringbooleanKeyValueOfstringbooleanItem) ? get_class($arrayOfKeyValueOfstringbooleanKeyValueOfstringbooleanItem) : sprintf('%s(%s)', gettype($arrayOfKeyValueOfstringbooleanKeyValueOfstringbooleanItem), var_export($arrayOfKeyValueOfstringbooleanKeyValueOfstringbooleanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The KeyValueOfstringboolean property can only contain items of type \patest\StructType\KeyValueOfstringboolean, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set KeyValueOfstringboolean value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\KeyValueOfstringboolean[] $keyValueOfstringboolean
     * @return \patest\ArrayType\ArrayOfKeyValueOfstringboolean
     */
    public function setKeyValueOfstringboolean(array $keyValueOfstringboolean = array())
    {
        // validation for constraint: array
        if ('' !== ($keyValueOfstringbooleanArrayErrorMessage = self::validateKeyValueOfstringbooleanForArrayConstraintsFromSetKeyValueOfstringboolean($keyValueOfstringboolean))) {
            throw new \InvalidArgumentException($keyValueOfstringbooleanArrayErrorMessage, __LINE__);
        }
        $this->KeyValueOfstringboolean = $keyValueOfstringboolean;
        return $this;
    }
    /**
     * Add item to KeyValueOfstringboolean value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\KeyValueOfstringboolean $item
     * @return \patest\ArrayType\ArrayOfKeyValueOfstringboolean
     */
    public function addToKeyValueOfstringboolean(\patest\StructType\KeyValueOfstringboolean $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\KeyValueOfstringboolean) {
            throw new \InvalidArgumentException(sprintf('The KeyValueOfstringboolean property can only contain items of type \patest\StructType\KeyValueOfstringboolean, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->KeyValueOfstringboolean[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\KeyValueOfstringboolean|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\KeyValueOfstringboolean|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\KeyValueOfstringboolean|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\KeyValueOfstringboolean|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\KeyValueOfstringboolean|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KeyValueOfstringboolean
     */
    public function getAttributeName()
    {
        return 'KeyValueOfstringboolean';
    }
}
